(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.2' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     15466,        474]
NotebookOptionsPosition[     12387,        410]
NotebookOutlinePosition[     13445,        440]
CellTagsIndexPosition[     13365,        435]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell[BoxData[
 RowBox[{"Quiet", "@", 
  RowBox[{"ConstrainedMin", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"2", " ", "x"}], "-", 
     RowBox[{"3", " ", "y"}]}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{"x", "+", "y"}], "<", "10"}], ",", 
      RowBox[{
       RowBox[{"x", "-", "y"}], ">", "2"}], ",", 
      RowBox[{"x", ">", "1"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"x", ",", "y"}], "}"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.9059951084002514`*^9, 3.9059951144534206`*^9}},
 CellTags->
  "LinearProgramming",ExpressionUUID->"c8af7cb0-830c-48ac-8f79-5224ef97b05f"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0", ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"x", "\[Rule]", "6"}], ",", 
     RowBox[{"y", "\[Rule]", "4"}]}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.843699663883998*^9, 3.9059951159999275`*^9},
 CellTags->
  "LinearProgramming",ExpressionUUID->"1b9de45e-1fbe-4301-9e52-1451f130b0eb"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"LinearProgramming", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"2", ",", 
     RowBox[{"-", "3"}]}], "}"}], ",", 
   RowBox[{"(", GridBox[{
      {
       RowBox[{"-", "1"}], 
       RowBox[{"-", "1"}]},
      {"1", 
       RowBox[{"-", "1"}]},
      {"1", "0"}
     }], ")"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "10"}], ",", "2", ",", "1"}], "}"}]}], "]"}]], "Input",
 CellTags->
  "LinearProgramming",ExpressionUUID->"335d2ed4-ffb2-4736-bb12-f7652814675a"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"6", ",", "4"}], "}"}]], "Output",
 CellChangeTimes->{3.843699663906126*^9},
 CellTags->
  "LinearProgramming",ExpressionUUID->"ae528e67-c78b-4609-b9ff-4673f7a3d807"]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{"fce", "=", 
   RowBox[{
    RowBox[{"x", "^", "3"}], "+", 
    RowBox[{"x", "*", 
     SuperscriptBox["y", "2"]}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"podminka", "=", 
   RowBox[{
    RowBox[{".02", "*", 
     RowBox[{"x", "^", "3"}]}], "+", 
    RowBox[{"0.05", "*", 
     SuperscriptBox["x", "2"], "*", "y"}], "+", 
    SuperscriptBox["y", "2"], "-", "6"}]}], 
  ";"}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{
  3.9059951244823422`*^9},ExpressionUUID->"629b8dd3-b7c2-4c18-b692-\
7d859c19d59f"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"lagrange", "=", 
   RowBox[{"fce", "+", 
    RowBox[{"\[Lambda]", "*", "podminka"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"res", "=", 
   RowBox[{
    RowBox[{"Quiet", "@", 
     RowBox[{"Solve", "[", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{
         RowBox[{"D", "[", 
          RowBox[{"lagrange", ",", "x"}], "]"}], "\[Equal]", "0"}], ",", 
        RowBox[{
         RowBox[{"D", "[", 
          RowBox[{"lagrange", ",", "y"}], "]"}], "\[Equal]", "0"}], ",", 
        RowBox[{"podminka", "\[Equal]", "0"}]}], "}"}], "]"}]}], "//", 
    "N"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.9059951362139254`*^9, 
  3.9059951376047635`*^9}},ExpressionUUID->"75fbd09c-4932-4bb5-946d-\
97c94884b774"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"data", "=", 
  RowBox[{"Select", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"{", 
      RowBox[{"x", ",", "y"}], "}"}], "/.", "res"}], ",", 
    RowBox[{
     RowBox[{
      RowBox[{"#", "[", 
       RowBox[{"[", "1", "]"}], "]"}], "\[Element]", "Reals"}], "&"}]}], 
   "]"}]}]], "Input",ExpressionUUID->"f98c4e70-1610-4df1-a563-702072e14242"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"7.288691475657752`", ",", 
     RowBox[{"-", "1.4684090963635708`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"32.02312036492725`", ",", 
     RowBox[{"-", "23.092495748456827`"}]}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{
  3.8436996641222625`*^9},ExpressionUUID->"81efd811-368e-429d-b6d2-\
c34855317e43"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"Quiet", "@", 
    RowBox[{"Remove", "[", "\"\<Global`*\>\"", "]"}]}], ";"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{"optimalizace", " ", "pro", " ", "reseni", " ", "rovnic"}], "*)"}],
   "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{"prave", " ", "urceny", " ", "system"}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"rce", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"x", "+", "y"}], "\[Equal]", "5"}], ",", 
     RowBox[{
      RowBox[{"x", "-", 
       RowBox[{"5", "y"}]}], "\[Equal]", "6."}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Solve", "[", "rce", "]"}]}], "Input",
 CellChangeTimes->{{3.9072105221689653`*^9, 3.907210550398608*^9}, {
  3.907210610040584*^9, 
  3.9072106643202543`*^9}},ExpressionUUID->"3f973ff3-2102-4348-b12f-\
0de3c26c1b18"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"x", "\[Rule]", "5.166666666666667`"}], ",", 
    RowBox[{"y", "\[Rule]", 
     RowBox[{"-", "0.1666666666666666`"}]}]}], "}"}], "}"}]], "Output",
 CellChangeTimes->{{3.9072106610083127`*^9, 
  3.907210664585569*^9}},ExpressionUUID->"8af79127-c93d-4b32-9f99-\
2182b5c05aaa"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", 
  RowBox[{
   RowBox[{"https", ":"}], "//", 
   RowBox[{
    RowBox[{"clintel", ".", "org"}], "/"}]}], "*)"}]], "Input",
 CellChangeTimes->{{3.9072125991558175`*^9, 
  3.9072126039400864`*^9}},ExpressionUUID->"1f1d688b-1b81-4119-a5e0-\
ee1fb42ae142"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"proMinimum", "=", 
  RowBox[{"Total", "[", 
   RowBox[{"rce", "/.", 
    RowBox[{
     RowBox[{"lhs_", "\[Equal]", "rhs_"}], "\[RuleDelayed]", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"lhs", "-", "rhs"}], ")"}], "2"]}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"NMinimize", "[", 
  RowBox[{"proMinimum", ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "y"}], "}"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.907210673896227*^9, 3.9072107112479687`*^9}, {
  3.9072107593616133`*^9, 
  3.9072107677762594`*^9}},ExpressionUUID->"afc69191-1524-4e64-9826-\
e9f2821af6c8"],

Cell[BoxData[
 RowBox[{
  SuperscriptBox[
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", "6.`"}], "+", "x", "-", 
     RowBox[{"5", " ", "y"}]}], ")"}], "2"], "+", 
  SuperscriptBox[
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", "5"}], "+", "x", "+", "y"}], ")"}], "2"]}]], "Output",
 CellChangeTimes->{{3.9072107048079696`*^9, 3.907210711731938*^9}, 
   3.9072107683383303`*^9},ExpressionUUID->"8905669b-5751-45cd-869c-\
3162e4affbfe"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"1.4251881588465545`*^-31", ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"x", "\[Rule]", "5.166666666666667`"}], ",", 
     RowBox[{"y", "\[Rule]", 
      RowBox[{"-", "0.16666666666666666`"}]}]}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{{3.9072107048079696`*^9, 3.907210711731938*^9}, 
   3.9072107683383303`*^9},ExpressionUUID->"aedc1e7e-7d2f-4b86-9853-\
400bcc6f690d"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"Quiet", "@", 
    RowBox[{"Remove", "[", "\"\<Global`*\>\"", "]"}]}], ";"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"https", ":"}], "//", 
    RowBox[{
     RowBox[{"clintel", ".", "org"}], "/"}]}], "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{"preurceny", " ", "system"}], "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"rn", ":=", 
   RowBox[{"RandomReal", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"-", "1"}], ",", "1"}], "}"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"nproms", "=", "3"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"nrci", "=", "5"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"proms", "=", 
   RowBox[{
    RowBox[{
     SubscriptBox["x", "#"], "&"}], "/@", 
    RowBox[{"Range", "[", "nproms", "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"rce", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"proms", ".", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"RandomReal", "[", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "1"}], ",", "1"}], "}"}], "]"}], "&"}], "/@", 
         RowBox[{"Range", "[", "nproms", "]"}]}], ")"}]}], "\[Equal]", "rn"}],
      ",", 
     RowBox[{"{", "nrci", "}"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"proMinimum", "=", 
   RowBox[{"Total", "[", 
    RowBox[{"rce", "/.", 
     RowBox[{
      RowBox[{"lhs_", "\[Equal]", "rhs_"}], "\[RuleDelayed]", 
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{"lhs", "-", "rhs"}], ")"}], "2"]}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"NMinimize", "[", 
  RowBox[{"proMinimum", ",", "proms"}], 
  "]"}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.907211040658655*^9, 3.907211230212926*^9}, {
  3.9072112665168743`*^9, 3.9072113343917956`*^9}, {3.9072126119652305`*^9, 
  3.9072126124134884`*^9}},ExpressionUUID->"496ddbe5-d030-4f8c-aec5-\
6332bd1242c5"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.3662896675024191`", ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      SubscriptBox["x", "1"], "\[Rule]", 
      RowBox[{"-", "0.4969491795883122`"}]}], ",", 
     RowBox[{
      SubscriptBox["x", "2"], "\[Rule]", "0.058223912255680424`"}], ",", 
     RowBox[{
      SubscriptBox["x", "3"], "\[Rule]", "1.2137520163716768`"}]}], "}"}]}], 
  "}"}]], "Output",
 CellChangeTimes->{{3.907211124478602*^9, 3.907211129227518*^9}, 
   3.907211230790864*^9, 3.907211270755184*^9, {3.9072113266216936`*^9, 
   3.907211335407179*^9}},ExpressionUUID->"4a7f541c-6b41-4efc-bfa3-\
24baf62c5e78"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"{", 
    RowBox[{"bpom", ",", "m"}], "}"}], "=", 
   RowBox[{
    RowBox[{"CoefficientArrays", "[", 
     RowBox[{"rce", ",", "proms"}], "]"}], "//", "Normal"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"MatrixForm", "/@", 
   RowBox[{"{", 
    RowBox[{"m", ",", 
     RowBox[{"b", "=", 
      RowBox[{"-", "bpom"}]}]}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Thread", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"m", "\[Transpose]"}], ".", "m", ".", "proms"}], "\[Equal]", 
    RowBox[{
     RowBox[{"m", "\[Transpose]"}], ".", "b"}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Solve", "[", "%", "]"}], "\[IndentingNewLine]", 
 RowBox[{"LinearSolve", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"m", "\[Transpose]"}], ".", "m"}], ",", 
   RowBox[{
    RowBox[{"m", "\[Transpose]"}], ".", "b"}]}], 
  "]"}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.907211375618639*^9, 3.907211492023611*^9}, {
  3.9072118582102413`*^9, 3.9072119371532106`*^9}, {3.9072119938734255`*^9, 
  3.9072119952009954`*^9}, {3.9072120591547413`*^9, 
  3.907212085203052*^9}},ExpressionUUID->"86243d2b-0465-421a-b47c-\
dabe550aea55"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{
     SubscriptBox["x", "1"], "\[Rule]", 
     RowBox[{"-", "0.49694917958831225`"}]}], ",", 
    RowBox[{
     SubscriptBox["x", "2"], "\[Rule]", "0.058223912255680375`"}], ",", 
    RowBox[{
     SubscriptBox["x", "3"], "\[Rule]", "1.2137520163716768`"}]}], "}"}], 
  "}"}]], "Output",
 CellChangeTimes->{{3.9072118835563397`*^9, 3.907211937949615*^9}, 
   3.907211995700823*^9, {3.9072120596702127`*^9, 
   3.9072120857966566`*^9}},ExpressionUUID->"7e93540c-72c2-4f49-a2d7-\
1240a0521c6f"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"-", "0.4969491795883122`"}], ",", "0.05822391225568031`", ",", 
   "1.2137520163716768`"}], "}"}]], "Output",
 CellChangeTimes->{{3.9072118835563397`*^9, 3.907211937949615*^9}, 
   3.907211995700823*^9, {3.9072120596702127`*^9, 
   3.907212085812277*^9}},ExpressionUUID->"466ed646-cd05-4bec-9d99-\
e0a47b9b5483"]
}, Open  ]]
},
WindowSize->{1098, 672},
WindowMargins->{{12, Automatic}, {Automatic, 15}},
PrivateNotebookOptions->{"VersionedStylesheet"->{"Default.nb"[8.] -> False}},
ShowSelection->True,
Magnification:>2.25 Inherited,
FrontEndVersion->"11.2 for Microsoft Windows (64-bit) (September 10, 2017)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "LinearProgramming"->{
  Cell[580, 22, 615, 18, 107, "Input",ExpressionUUID->"c8af7cb0-830c-48ac-8f79-5224ef97b05f",
   CellTags->"LinearProgramming"],
  Cell[1198, 42, 342, 9, 72, "Output",ExpressionUUID->"1b9de45e-1fbe-4301-9e52-1451f130b0eb",
   CellTags->"LinearProgramming"],
  Cell[1577, 56, 504, 18, 133, "Input",ExpressionUUID->"335d2ed4-ffb2-4736-bb12-f7652814675a",
   CellTags->"LinearProgramming"],
  Cell[2084, 76, 205, 5, 72, "Output",ExpressionUUID->"ae528e67-c78b-4609-b9ff-4673f7a3d807",
   CellTags->"LinearProgramming"]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"LinearProgramming", 12824, 423}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[580, 22, 615, 18, 107, "Input",ExpressionUUID->"c8af7cb0-830c-48ac-8f79-5224ef97b05f",
 CellTags->"LinearProgramming"],
Cell[1198, 42, 342, 9, 72, "Output",ExpressionUUID->"1b9de45e-1fbe-4301-9e52-1451f130b0eb",
 CellTags->"LinearProgramming"]
}, Open  ]],
Cell[CellGroupData[{
Cell[1577, 56, 504, 18, 133, "Input",ExpressionUUID->"335d2ed4-ffb2-4736-bb12-f7652814675a",
 CellTags->"LinearProgramming"],
Cell[2084, 76, 205, 5, 72, "Output",ExpressionUUID->"ae528e67-c78b-4609-b9ff-4673f7a3d807",
 CellTags->"LinearProgramming"]
}, Open  ]],
Cell[2304, 84, 565, 18, 150, "Input",ExpressionUUID->"629b8dd3-b7c2-4c18-b692-7d859c19d59f"],
Cell[2872, 104, 762, 22, 193, "Input",ExpressionUUID->"75fbd09c-4932-4bb5-946d-97c94884b774"],
Cell[CellGroupData[{
Cell[3659, 130, 368, 11, 63, "Input",ExpressionUUID->"f98c4e70-1610-4df1-a563-702072e14242"],
Cell[4030, 143, 387, 11, 72, "Output",ExpressionUUID->"81efd811-368e-429d-b6d2-c34855317e43"]
}, Open  ]],
Cell[CellGroupData[{
Cell[4454, 159, 874, 26, 264, "Input",ExpressionUUID->"3f973ff3-2102-4348-b12f-0de3c26c1b18"],
Cell[5331, 187, 343, 9, 100, "Output",ExpressionUUID->"8af79127-c93d-4b32-9f99-2182b5c05aaa"]
}, Open  ]],
Cell[5689, 199, 280, 8, 63, "Input",ExpressionUUID->"1f1d688b-1b81-4119-a5e0-ee1fb42ae142"],
Cell[CellGroupData[{
Cell[5994, 211, 611, 17, 141, "Input",ExpressionUUID->"afc69191-1524-4e64-9826-e9f2821af6c8"],
Cell[6608, 230, 439, 13, 100, "Output",ExpressionUUID->"8905669b-5751-45cd-869c-3162e4affbfe"],
Cell[7050, 245, 420, 10, 106, "Output",ExpressionUUID->"aedc1e7e-7d2f-4b86-9853-400bcc6f690d"]
}, Open  ]],
Cell[CellGroupData[{
Cell[7507, 260, 2052, 62, 587, "Input",ExpressionUUID->"496ddbe5-d030-4f8c-aec5-6332bd1242c5"],
Cell[9562, 324, 628, 16, 100, "Output",ExpressionUUID->"4a7f541c-6b41-4efc-bfa3-24baf62c5e78"]
}, Open  ]],
Cell[CellGroupData[{
Cell[10227, 345, 1213, 35, 307, "Input",ExpressionUUID->"86243d2b-0465-421a-b47c-dabe550aea55"],
Cell[11443, 382, 561, 15, 100, "Output",ExpressionUUID->"7e93540c-72c2-4f49-a2d7-1240a0521c6f"],
Cell[12007, 399, 364, 8, 100, "Output",ExpressionUUID->"466ed646-cd05-4bec-9d99-e0a47b9b5483"]
}, Open  ]]
}
]
*)

(* End of internal cache information *)

